;
        title   GeneSys Opcode CardFile, 1.0.0
; ___________________________________________________
;|                                                   |
;| GeneSys Opcode CardFile, 1.0.0      Paul Brennick |
;| pebrennick@verizon.net   http://www.pbrennick.com |
;|___________________________________________________|
;|                                                   |
;| Version key:  GeneSys Opcode CardFile a.b.c       |
;|           a:  a major change to the GUI           |
;|           b:  functions added and/or changed      |
;|           c:  bug fixes                           |
;|                                                   |
;| Version History:                                  |
;| October 27, 2006   Major rewrite and first        |
;|                    release of the software        |
;|                    Version tracking starts        |
;|                    from this point, on.           |
;|                                                   |
;| Written by: Paul Brennick                         |
;| Email     : pebrennick@verizon.net                |
;| Page      : http://www.pbrennick.com/             |
;| Compiler  : Microsoft Macro Assembler v6.14.8444  |
;| Date      : 27-Oct-2006                           |
;| Purpose   : This Opcode CardFile Manager can be   |
;|           : used to examine various MASM Opcodes  |
;|           : and Mnemonics.                        |
;|                                     Editor's Note |
;|___________________________________________________|
;|                                                   |
        .486      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|
;
;       Include Files
;       ----------------------------------------
        include \GeneSys\include\windows.inc
        include \GeneSys\include\user32.inc
        include \GeneSys\include\kernel32.inc
        include \GeneSys\include\shell32.inc
        include \GeneSys\include\gdi32.inc
        include \GeneSys\include\wsock32.inc
;
;       Libraries
;       ----------------------------------------
        includelib \GeneSys\lib\user32.lib
        includelib \GeneSys\lib\kernel32.lib
        includelib \GeneSys\lib\shell32.lib
        includelib \GeneSys\lib\gdi32.lib
        includelib \GeneSys\lib\wsock32.lib
;
; Prototype, Constants and Data sections, index to Declared Procedures
;-----------------------------------------------
WinMain         proto :DWORD, :DWORD, :DWORD, :DWORD
AboutDlgProc    proto :HWND, :DWORD, :WPARAM, :LPARAM
ASCIIscan       proto :HWND
OpenASCII       proto :HWND
;
.data
;---------------------------------------
ClassName       db  "DLGCLASS", 0
MenuName        db  "MyMenu", 0
DlgName         db  "MainDialog", 0
AbtName         db  "AboutDialog", 0
num2            db  "%lu", 0
hInstance       HINSTANCE   ?
CommandLine     LPSTR       ?
buff            db  256 dup (?)
menuhand        DWORD       ?
first           BOOL        FALSE
ASCIIname       db  "preview.txt", 0
ASCIIdata       db  "fld1"
                db  "fld2"
                db  "fld3"
                db  "fld4"
                db  "fld5"
szOpen          db  "open", 0
;
.data?
;---------------------------------------
hwnd            HWND    ?
hover           BOOL    ?
hFinger         dd      ?
orgStatic       dd      ?
hwndDlg         dd      ?
filehand1       dword   ?
memhand         dword   ?
filesize        dword   ?
mem             dword   ?
sizeread        dword   ?
temp            dword   ?
memdata         dword   ?
parts           dword   ?
memmax          dword   ?
index           dword   ?
;
.const
;---------------------------------------
IDC_NEXT        equ     3000
IDC_PREV        equ     3001
IDC_EXIT        equ     3002
IDM_UPDATE      equ     32000
IDM_EXIT        equ     32003
IDM_ABOUT       equ     32002
IDI_ICON1       equ     5
IDC_URL         equ     9
;
;
.code
;---------------------------------------
start:  invoke  GetModuleHandle, NULL
        mov     hInstance, eax
        invoke  GetCommandLine
        invoke  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
        invoke  ExitProcess, eax
;
;
WinMain proc    hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
;---------------------------------------
        LOCAL   wc:WNDCLASSEX
        LOCAL   msg:MSG
        LOCAL   hDlg:HWND
;
        mov     wc.cbSize, SIZEOF WNDCLASSEX
        mov     wc.style, CS_HREDRAW or CS_VREDRAW
        mov     wc.lpfnWndProc, OFFSET WndProc
        mov     wc.cbClsExtra, NULL
        mov     wc.cbWndExtra, DLGWINDOWEXTRA
        push    hInst
        pop     wc.hInstance
        mov     wc.hbrBackground, COLOR_BTNFACE+1
        mov     wc.lpszMenuName, OFFSET MenuName
        mov     wc.lpszClassName, OFFSET ClassName
        invoke  LoadIcon, hInstance, IDI_ICON1
        mov     wc.hIcon, eax
        mov     wc.hIconSm, eax
        invoke  LoadCursor, NULL, IDC_ARROW
        mov     wc.hCursor, eax
        invoke  RegisterClassEx, addr wc
        invoke  CreateDialogParam, hInstance, ADDR DlgName, NULL, NULL, NULL
        mov     hDlg, eax
        invoke  ShowWindow, hDlg, SW_SHOWNORMAL
        invoke  UpdateWindow, hDlg
        .while TRUE
          invoke GetMessage, ADDR msg, NULL, 0, 0
          .BREAK .if (!eax)
          invoke IsDialogMessage, hDlg, ADDR msg
          .if eax==FALSE
            invoke  TranslateMessage, ADDR msg
            invoke  DispatchMessage, ADDR msg
          .endif
        .endw
        mov     eax, msg.wParam
        ret
;---------------------------------------
WinMain endp
;
;
WndProc proc    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, uMsg
        .if ax==WM_GETMINMAXINFO        ; 24
          cmp     first, FALSE
          jne     nob1
          invoke  GetMenu, hWnd
          mov     menuhand, eax
          invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
          invoke  OpenASCII, hWnd
          mov     eax, mem
          mov     memdata, eax
          mov     index, 1
          ret
        .elseif ax==WM_INITDIALOG
        .elseif ax==WM_ACTIVATE
          cmp     mem, 0
          jne     okok2
          mov     eax, mem
          mov     memdata, eax
          invoke  OpenASCII, hWnd
okok2:    invoke  ASCIIscan, hWnd
          mov     eax, parts
          push    eax
          push    offset num2
          push    offset buff
          call    wsprintfA
          invoke  SendDlgItemMessage, hWnd, 506, WM_SETTEXT, 0, ADDR buff
          ret
        .elseif ax==WM_DESTROY
          invoke  GlobalFree, memhand
          invoke  PostQuitMessage, NULL
          ret
        .elseif ax==WM_COMMAND
          mov     eax, wParam
          .if lParam==0
            .if ax==IDM_EXIT
              invoke  DestroyWindow, hWnd
              ret
            .elseif ax==IDC_NEXT
              jmp     gonext
            .elseif ax==IDC_PREV
              jmp     goprev
            .elseif ax==IDM_ABOUT
              invoke  CreateDialogParam, hInstance, addr AbtName, hWnd, OFFSET AboutDlgProc, NULL
              mov     hwndDlg, eax
            .endif
          .else
            .if ax==IDC_EXIT
              invoke  SendMessage, hWnd, WM_COMMAND, IDM_EXIT, 0
              ret
            .elseif ax==IDC_NEXT
gonext:       mov     ebx, index
              cmp     ebx, parts
              jae     toobig
              mov     esi, memdata
              add     esi, 4
              cmp     esi, memmax
              jae     toobig
gosi:         inc     esi
              cmp     esi, memmax
              je      toobig
              cmp     [esi], word ptr 0d0ah     ; CRLF?
              jne     gosi
              add     esi, 3
              mov     memdata, esi
              inc     index
              invoke  ASCIIscan, hWnd
toobig:     .elseif ax==IDC_PREV
goprev:       mov     ebx, index
              or      ebx, ebx
              jz      nodec
              mov     esi, memdata
              cmp     esi, mem
              je      nodec
              sub     esi, 4
gosi2:        dec     esi
              cmp     esi, mem
              je      foundtop
              cmp     [esi], word ptr 0d0ah     ; CRLF?
              jne     gosi2
              add     esi, 3
foundtop:     mov     memdata, esi
              dec     index
              invoke  ASCIIscan, hWnd
nodec:      .endif
          .endif
        .else
          invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
          ret
        .endif
nob1:   xor     eax, eax
        ret
;---------------------------------------
WndProc endp
;
;
HyperLinkWndProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
        LOCAL   tmpFont:LOGFONT
        LOCAL   rect:RECT
        LOCAL   pt:POINT
;
        mov     eax, uMsg
        .if eax==WM_NCHITTEST
          mov     eax, 1                ; We want to handle the non client hit test so we return true or 1
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          push    ebx
          push    edx
          invoke  SendMessage, hWnd, WM_GETFONT, 0, 0
          mov     edx, eax
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont
          mov     tmpFont.lfUnderline, TRUE
          invoke  CreateFontIndirect, addr tmpFont
          mov     ebx, eax
          invoke  SelectObject, wParam, ebx
          .if hover == FALSE
            invoke  SetTextColor, wParam, Blue
          .else
            invoke  SetTextColor, wParam, Red
          .endif
          invoke  GetSysColor, COLOR_MENU
          invoke  SetBkColor, wParam, eax
          invoke  DeleteObject, ebx
          invoke  GetStockObject, HOLLOW_BRUSH
          pop     edx
          pop     ebx
          ret
        .elseif eax==WM_MOUSEMOVE
          invoke  GetParent, hWnd
          push    ebx
          mov     ebx, eax
          invoke  GetActiveWindow
          .if eax == ebx
            invoke  GetCursorPos, addr pt
            invoke  GetWindowRect, hWnd, addr rect
            invoke  PtInRect, addr rect, pt.x, pt.y
            .if eax
              invoke  GetCapture
              .if !eax
                invoke  SetCapture, hWnd
                mov     hover, TRUE
                invoke  InvalidateRect, hWnd, FALSE, FALSE
                invoke  SetCursor, hFinger
              .endif
            .else
              invoke  GetCapture
              .if eax
                invoke  ReleaseCapture
                mov     hover, FALSE
                invoke  InvalidateRect, hWnd, FALSE, FALSE
              .endif
            .endif
          .endif
          pop     ebx
          xor     eax, eax
          ret
        .elseif eax==WM_LBUTTONDOWN
          invoke  GetWindowText, hWnd, offset buff, sizeof buff ; Change this for using a preset url
          invoke  ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE   ; Change this to represent your preset url
          mov     hover, FALSE
          invoke  InvalidateRect, hWnd, FALSE, FALSE
          invoke  SendMessage, hWnd, WM_GETFONT, 0, 0           ; Get the defualt system font
          mov     edx, eax                                      ; Store result
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get our font into a logfont structure
          mov     tmpFont.lfUnderline, TRUE                     ; Under line the link
          invoke  CreateFontIndirect, addr tmpFont              ; Create the new font
          mov     ebx, eax                                      ; We need the return to free the memory later
          invoke  SelectObject, wParam, ebx                     ; Select our control
          invoke  SetTextColor, wParam, Blue                    ; Change this to change the color of the link
          xor     eax, eax
          ret
        .endif
        invoke  CallWindowProc, orgStatic, hWnd, uMsg, wParam, lParam
        ret
;---------------------------------------
HyperLinkWndProc endp
;
;
AboutDlgProc proc hWnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, iMsg
        .if eax==WM_INITDIALOG
          invoke  GetDlgItem, hWnd, IDC_URL
          invoke  SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
          mov     orgStatic, eax
          mov     hFinger, eax
          xor     eax, eax
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          invoke  SendMessage, lParam, iMsg, wParam, lParam
          ret
        .elseif eax==WM_CLOSE
          invoke  EndDialog, hWnd, NULL
          mov hwndDlg,0
        .elseif eax==WM_COMMAND
          push    edx
          mov     eax, wParam
          mov     edx, eax
          shr     edx, 16
          .if eax==IDC_EXIT
            invoke  SendMessage, hWnd, WM_CLOSE, NULL, NULL
            invoke  EndDialog, hWnd, NULL
            mov     hwndDlg, 0
          .endif
          pop     edx
        .else
          mov     eax, FALSE
          ret
        .endif
        mov      eax, TRUE
        ret
;---------------------------------------
AboutDlgProc endp
;
;
OpenASCII proc  hWnd:HWND
;---------------------------------------
        invoke  CreateFile, ADDR ASCIIname, GENERIC_READ, 0, \
                NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
        cmp     eax, INVALID_HANDLE_VALUE
        je      notop1
        mov     filehand1, eax
        invoke  GetFileSize, filehand1, addr temp
        mov     filesize, eax
        invoke  GlobalAlloc, GMEM_MOVEABLE + GMEM_ZEROINIT, filesize
        mov     memhand, eax
        invoke  GlobalLock, eax
        mov     mem, eax
        mov     esi, eax
        mov     [esi], dword ptr 1
        invoke  ReadFile, filehand1, mem, filesize, addr sizeread, NULL
        mov     esi, mem
        mov     ecx, filesize
        mov     ebx, ecx
        add     ebx, esi
        mov     memmax, ebx
        xor     eax, eax 
notset: inc     esi
        cmp     [esi], dword ptr 031646c66h
        jne     notset2
        inc     eax
notset2:
        loop    notset
        inc     eax
        mov     parts, eax
notop1: ret
;---------------------------------------
OpenASCII endp
;
;
ASCIIscan proc  hWnd:HWND
;---------------------------------------
        mov     esi, memdata
bigtry: lea     edi, ASCIIdata
        xor     ecx, ecx
retry:  mov     al, [esi]
        cmp     al, [edi]
        jne     notit
        xor     ch, ch
        push    esi
        push    edi
retry1: inc     esi
        inc     edi
        mov     al, [esi]
        cmp     al, [edi]
        jne     notit2
        inc     ch
        cmp     ch, 3
        jb      retry1
        xor     eax, eax
        mov     al, cl
        add     eax, 501
        inc     esi
        inc     esi
        invoke  SendDlgItemMessage, hWnd, eax, WM_SETTEXT, 0, esi
notit2: pop     edi
        pop     esi
notit:  add     edi, 4
        inc     cl
        cmp     cl, 6
        jb      retry
foundone:
        cmp     esi, memmax
        jae     overit
        inc     esi
        cmp     [esi], byte ptr 0ah
        jne     foundone
        cmp     esi, memmax
        jae     overit
        inc     esi
        cmp     [esi], byte ptr 0dh
        jne     bigtry
overit: mov     eax, index
        push    eax
        push    offset num2
        push    offset buff
        call    wsprintfA
        invoke  SendDlgItemMessage, hWnd, 507, WM_SETTEXT, 0, ADDR buff
        ret
;---------------------------------------
ASCIIscan endp
;
;
        end     start

